#!/usr/bin/perl -w 

#use strict; 
use MIME::Parser;
use MIME::Entity;
use MIME::Base64;
use Net::POP3;
#use Net::POP3_ssl;
use XMLRPC::Lite;

# User Configurable Variables
my $username = 'xxxx'; ## CHANGE THIS LINE
my $password = 'xxxx';  ## CHANGE THIS LINE
#my $pop = Net::POP3_ssl->new('pop.gmail.com', Timeout => 15, Debug => 1);  ## CHANGE THIS LINE
my $pop = Net::POP3->new('mailserver.com', Timeout => 15);  ## CHANGE THIS LINE
my $max_chars = 70;  # Number of chars to allow in a line of text from an incoming message ## CHANGE THIS LINE
my $temp_folder = "...."; ## CHANGE THIS LINE
my $attachment_output_folder = ""; ## CHANGE THIS LINE
my $attachment_output_folder_relative = "xxxx"; ## CHANGE THIS LINE
my $delete_messages = 1; # Delete messages from your inbox as they are processed
my $delete_temp_files = 1; # Delete temporary files that are created
my $print_output = 1; # Print output
my $post_to_blog = 1; # Post to your blog?
my $use_gif = 0; # 1 to allow GIF's as attachments, 0 to not allow them (T-Mobile issues)
my $blog_xmlrpc_url = "xxx"; ## CHANGE THIS LINE
my $blog_id = 2; ## CHANGE THIS LINE
my $blog_username = "xxx"; ## CHANGE THIS LINE
my $blog_password = "xxx"; ## CHANGE THIS LINE
my @bad_attachments = ("masthead.jpg"); # A list of attachment filename regular expressions that you don't want included 
my $umask = '0002';  # File creation to 775, 0022 would be 755

###
# Parsing Subroutine
###
sub parseMessageParts
{
    my @messageParts = @_;
    
    my $partnum = 0;
    my $is_mime_message = 0;

    while(my $part = shift(@messageParts)) 
    {       
            $is_mime_message = 1;  # Yes we have a mime message
            # Get the Mime type of the part
            my $type=$part->head->mime_type || $part->head->effective_type; 
            if ($type =~ /image\/jpeg/ || $type =~ /image\/jpg/)
            {     
                for (my $i = 0; $i <= $#bad_attachments; $i++)
                {          
                    if ($part->head->recommended_filename =~ $bad_attachments[$i])
                    {
                        $skip = 1;
                    }
                }
                
                if (!$skip)
                {
                    # Give me the entire body as one string (probably bad because these could be BIG attachments)
                    my $image = $part->bodyhandle->as_string;
                    my $file_name = "picture_" . time() . $partnum . ".jpg"; ## Make names uinque
                    my $image_file = $attachment_output_folder . $file_name;
                    my $fh = new FileHandle "> $image_file";
                    if (defined $fh) {
                            print $fh $image;
                            $fh->close;
                    }
                
                    $attachments[++$#attachments] = $file_name;
                    $attachments_type[++$#attachments_type] = "jpeg";
                    $attachments_relative[++$#attachements_relative] = $attachment_output_folder_relative . $file_name;
                }
            }
            elsif ($type =~ /image\/gif/i)
            {
                if ($use_gif)
                {
                    # Give me the entire body as one string (probably bad because these could be BIG attachments)
                    my $image = $part->bodyhandle->as_string;
                    my $file_name = "picture_" . time() . $partnum . ".gif"; ## Make names uinque
                    my $image_file = $attachment_output_folder . $file_name;
                    my $fh = new FileHandle "> $image_file";
                    if (defined $fh) 
                    {
                        print $fh $image;
                        $fh->close;
                    }
                
                    $attachments[++$#attachments] = $file_name;
                    $attachments_type[++$#attachments_type] = "gif";
                    $attachments_relative[++$#attachements_relative] = $attachment_output_folder_relative . $file_name;
                }
            }
            elsif ($type =~ /text\/plain/i)
            {
                my $message_bodyhandle = $part->bodyhandle;
                $mime_message_body = $message_bodyhandle->as_string;
                
                @mime_message_array = split('\n',$mime_message_body);
                my $done = 0;
                foreach $message_line (@mime_message_array)
                {                    
                    if ($message_line =~ /^\n/ ||
                            $message_line =~ /^\s*\n/ ||
                            $message_line !~ /\w/)
                    {
                       # Ignore blank lines
                    }
                    elsif (length $message_line  > $max_chars)
                    {
                       # Ignore lines too long to be text messages
                    }
                    elsif (!$done)
                    {
                        $message_body = $message_line; # Only grabbing first line
                        $done = 1;
                    }                                
                }
                
                $body .= $message_body;
            }                       
            elsif ($type =~ /text\/html/i)
            {
                # Plain Text portions or attachments
                my $message_bodyhandle = $part->bodyhandle;
                $mime_message_body = $message_bodyhandle->as_string;
                
                @mime_message_array = split('\n',$mime_message_body);
                my $done = 0;
                foreach $message_line (@mime_message_array)
                {
                    $message_line =~ s/<.*>//gi; # Strip out any HTML tags
                    
                    if ($message_line =~ /^\n/ ||
                            $message_line =~ /^\s*\n/ ||
                            $message_line !~ /\w/)
                    {
                       # Ignore blank lines
                    }
                    elsif (length $message_line  > $max_chars)
                    {
                       # Ignore lines too long to be text messages
                    }
                    elsif (!$done)
                    {
                        $message_body = $message_line; # Only grabbing first line
                        $done = 1;
                    }                                
                }
                
                ## Only set to body of message if no text bodies were already saved
                if ($body eq "")
                {
                    $body = $message_body;
                }
            }
            elsif ($type =~ /video\/3gpp/i)
            {
                # Video Mail
                # Give me the entire body as one string (probably bad because these could be BIG images)
                my $video = $part->bodyhandle->as_string;
                my $file_name = "video_" . time() . $partnum . ".3gp"; ## Make names uinque
                my $video_file = $image_output_folder . $file_name;
                my $fh = new FileHandle "> $video_file";
                if (defined $fh) {
                        print $fh $video;
                        $fh->close;
                }

                $attachments[++$#attachments] = $file_name;
                $attachments_type[++$#attachments_type] = "3gpp";
                $attachments_relative[++$#attachements_relative] = $attachment_output_folder_relative . $file_name;
            }
            elsif ($type =~ /audio\/x-wav/i)
            {
                my $audio = $part->bodyhandle->as_string;
                my $file_name = "audio_" . time() . $partnum . ".wav"; ## Make names uinque
                my $audio_file = $image_output_folder . $file_name;
                my $fh = new FileHandle "> $audio_file";
                if (defined $fh) {
                        print $fh $audio;
                        $fh->close;
                }
                
                $attachments[++$#attachments] = $file_name;
                $attachments_type[++$#attachments_type] = "wav";
                $attachments_relative[++$#attachements_relative] = $attachment_output_folder_relative . $file_name;
            } 
            elsif ($type =~ /multipart\/.*/i || $type =~ /message\/.*/i)
            {
                # Multipart Message, Parse This Again
                # Thanks again T-Mobile
                my @otherparts=$part->parts;
                &parseMessageParts(@otherparts);
            }
            else
            {
                if ($print_output)
                {
                    print "Other Types " . $type . "\n\n"; # OUTPUT
                }
            }
            $partnum++;
    }
    return $is_mime_message;
}

###
# Main Program Execution
###
if ($pop->login($username, $password)) 
{
        $umask = oct($umask) if $umask =~ /^0/;
        umask $umask;

        if ($print_output)
        {
            print(localtime() . "\n");
        }
        
        # Create the parser object
        my $parser = MIME::Parser->new();
        $parser->output_dir($temp_folder);
        
        my $msgnums = $pop->list; # hashref of msgnum => size
        foreach my $msgnum (keys %$msgnums) 
        {
                my $msg = $pop->get($msgnum); 
                
               	###
                # TO GET RAW DATA
                ###
                #foreach my $messageline (@$msg)
                #{
                #   chomp($messageline);
                #	print $messageline;
                #	if ($messageline =~ /^\!.*/)
                #	{
                #		print "******** fount it! ******";
                #		print $messageline;
                #	}
                #}

                my $entity = $parser->parse_data($msg);
                #my $entity = $parser->parse(\*STDIN); // For testing with message file  -- perl myphoto.pl < message
                
                ###
                # GET MESSAGE HEADER
                ###
                my $msg_head = $entity->head;
                my $subject = "";
                my $to = "";
                my $from = "";
                
                ###
                # MESSAGE Related Vars
                ###
                $body = "";
                @attachments = ();
                @attachments_type = ();
                @attachments_relative = ();
                
                ##
                # GET MESSAGE SUBJECT
                ##
                if ($msg_head->count('Subject') > 0)
                {
	                $subject = $msg_head->get('Subject');            
                }
                
                ##
                # GET MESSAGE FROM
                ##
                if ($msg_head->count('From') > 0)
                {
	                $from = $msg_head->get('From');
	                if ($from =~ /<(.*)>/)
		            {
		            	$from = $1;
		            }
	            }
	            
                ##
                # GET MESSAGE TO
                ##
	            if ($msg_head->count('To') > 0)
	            {
	                $to = $msg_head->get('To');
	                if ($to =~ /<(.*)>/)
		            {
		            	$to = $1;
		            }	                
	            }
                
                ###
                # GET MESSAGE PARTS (BODY AND ATTACHMENTS)
                ###
                my @parts=$entity->parts;
                my $is_mime = &parseMessageParts(@parts);
                                
                ##
                # IF IT ISN'T A MIME MESSAGE (NO ATTACHMENTS)
                ##
                if (!$is_mime)
                {
					###
					# GET MESSAGE BODY LINES
					###
					$msg_body = $entity->body;
					my $message_body = "";
					my $done = 0;
					foreach $message_line (@$msg_body)
					{
						if ($message_line =~ /^\n/)
						{
						
						}
						elsif (!$done)
						{
							$message_body = $message_line;
							$done = 1;
						}
                    }
                   	$body = $message_body;
                }
                
                chomp($to);
                chomp($from);
                chomp($subject);
                chomp($body);
                
                if ($post_to_blog)
                {
                    my $attachment_html = "";
                    for (my $i = 0; $i <= $#attachments; $i++)
                    {
                        my $attachment = $attachments[$i];
                        my $attachment_type = $attachments_type[$i];
                        my $attachment_relative = $attachments_relative[$i];
                        
                        if ($attachment_type eq "jpeg" || $attachment_type eq "gif")
                        {
                            $attachment_html .= "<img src=\"$attachment_relative\">\n";
                        }
                        elsif ($attachment_type eq "3gpp")
                        {
                            $attachment_html .= "
                              <OBJECT CLASSID=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\" WIDTH=\"320\" HEIGHT=\"257\" CODEBASE=\"http://www.apple.com/qtactivex/qtplugin.cab\">\n
                                  <PARAM name=\"SRC\" VALUE=\"$attachment_relative\">\n
                                  <PARAM name=\"AUTOPLAY\" VALUE=\"false\">\n
                                  <PARAM name=\"CONTROLLER\" VALUE=\"true\">\n
                                <EMBED SRC=\"$attachment_relative\" WIDTH=\"320\" HEIGHT=\"257\" AUTOPLAY=\"false\" CONTROLLER=\"true\" PLUGINSPAGE=\"http://www.apple.com/quicktime/download/\"></EMBED>\n
                              </OBJECT>\n             
                            ";
                        }
                        elsif ($attachment_type eq "wav")
                        {
                                    $attachment_html .= "
                                        <a href=\"$attachment_relative\">Audio Post</a>\n
                                    ";
                        }
                    }
                    
                    my $postresult=XMLRPC::Lite
                               ->proxy($blog_xmlrpc_url)
                               ->call('metaWeblog.newPost',$blog_id,$blog_username,$blog_password,
                                {
                                'title'=>$subject,
                                'description'=>$body . $attachment_html,
                                'mt_allow_comments'=>1,
                                'mt_allow_pings'=>1
                                },
                                1
                    )
                    ->result;
                }
                
                if ($print_output)
                {
                    print "Message To: $to\n";
                    print "Message From $from\n";
          			print "Message Subject $subject\n";
    				print "Message Body $body\n";
    				for (my $i = 0; $i <= $#attachments; $i++)
    				{
        				print "Message Attachment $attachments[$i] $attachments_type[$i] $attachments_relative[$i]\n";
                    }
                    print "--------------------------\n";
                }
            
            	if ($delete_messages)
            	{
	                $pop->delete($msgnum);
	            }

        		if ($delete_temp_files)
        		{	
	    	    	$parser->filer->purge;
	    		}	    		
        }
}
$pop->quit;
